<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

// require 'customListItem.ifc.php';
require_once 'customListIterator.php';

/**
 * Description of List
 *
 * @author pc1
 */
class customList {
    
    private $ordered = true;
    protected $list;
    private static $loopFlag = false;
 
    
    public function  customList($ordered = true) {
        $this->list = array();
        $this->ordered = $ordered;
    }

    /**
     * Retorna array de objetos generados.
     * 
     * @return Array objects
     */
    public function getList() {
        return $this->list;
    }
    
    public function setOrderedList() {
        $this->ordered = true;   
    }
    
    public function setUnorderedList() {
        $this->ordered = false;
    }

    public function add(customListItemIfc $object) {        
        $idx = $object->getListIndex();
        if (!$idx and !$this->ordered)
            $this->list[] = $object;
        else 
            $this->list[$idx] = $object;
    }

    /**
     * Retorna el objeto de indice = $index
     * @param int $index, indice getListIndex para acceder al objeto de indice indicado
     * 
     * @return Object
     */
    public function get($index) {
        return $this->list[$index];
    }
    
    public function getSize() {
        return sizeof($this->list);
    }
    
    /**
     * Retorna el proximo objeto.
     * 
     * 
     * @return Object
     */    
    public function getNext() {
        $_ret = next($this->list);
        return $_ret;
    }
    
    /**
     * Retorna el objeto actual.
     * 
     * 
     * @return Object
     */    
    public function getCurrent() {
        $_ret = current($this->list);
        return $_ret;
    }
        
    public function resetList() {
        reset($this->list);
    }
    
    public function getN_Items($_from,$_qty) {
        $_ret = new CustomList();        
        $this->resetList();
        $_item = $this->getCurrent();
        $i = 0;
        $_total = $_from + $_qty;
        while($_item and $i<$_total) {
            if ($i >= $_from)  $_ret->add($_item);
            $_item = $this->getNext();
            $i++;
        }
                        
        return $_ret;        
        
    }    
    
    public function toArray() {
        $_list = array();
        
        $this->resetList();        
        $_item = $this->getCurrent();
        while($_item) {          

            if (method_exists($_item, "toArray")) {
                $idx = $_item->getListIndex();
                if (!$idx and !$this->ordered)
                    $_list[] = $_item->toArray();
                else
                    $_list[$idx] = $_item->toArray();
            }

            $_item = $this->getNext();
        }
        return $_list;
    }


    /**
     * @return customListIterator
     */
    public function getIterator(){
        return new customListIterator($this->list);
    }

}
?>
