<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

require_once 'ActionDispatcher.php';
require_once 'lib/customlib/util/Secure_PostGet_Vars.class.php';

/**
 * Description of RequestDispatcher
 *
 * @author gustavo
 */
class RequestDispatcher {

    const ACTION_VARNAME = "action";
    const PARAMS_VARNAME = "params";
    const DISPATCHER_VARNAME = "dispatcher";

    private $action;
    private $dispatcher;
    private $params;

    function __construct() {
        
        $action = Secure_PostGet_Vars::get_Get(self::ACTION_VARNAME);
        $dispatcher = Secure_PostGet_Vars::get_Get(self::DISPATCHER_VARNAME);
        $params = Secure_PostGet_Vars::get_Get(self::PARAMS_VARNAME);

        if (isset($action))
            $this->action = $action;

        if (isset($dispatcher))
            $this->dispatcher = $dispatcher;
        if (isset($params))
            $this->params = $params;
    }

    public function performAction() {
              
        switch ($this->action) {
            default:
                $_ActionDispatcher = new ActionDispatcher($this->dispatcher, $this->action, $this->params);
                $_ActionDispatcher->performAction();
                break;

        }
                
    }

    public function PerformDispacher() {
        if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
            return false;
        } else {
            if (isset($this->action))
                $this->performAction ();
        }
    }
    
    function getAction() {
        return $this->action;
    }

    function getDispatcher() {
        return $this->dispatcher;
    }

    function getParams() {
        return $this->params;
    }

    function setAction($action) {
        $this->action = $action;
    }

    function setDispatcher($dispatcher) {
        $this->dispatcher = $dispatcher;
    }

    function setParams($params) {
        $this->params = $params;
    }


}
