<?php

require_once 'lib/customlib/common/cast/Cast.class.php';
require_once 'ModalAdministrableDAO.php';

/**
 * Class ModalAdministrable
 */
class ModalAdministrable extends ModalAdministrableDAO {


    function __construct() {
        parent::__construct();
    }

    /**
     *
     * @param json $postObj
     * @return ModalAdministrable
     */
    static public function getInstantiatedFromPostJsonObject($postObj) {
        $_ret = new ModalAdministrable();
        Cast::getInstantiatedEntityFromJsonObject($_ret, $postObj);
        return $_ret;
    }

    /**
     * @return array
     */
    public function toArray(){
        return cast::entityToArray($this);
    }

    /**
     * @return ModalAdministrable
     */
    static public function getInstance() {
        $_ret = new ModalAdministrable();
        return $_ret->get();
    }

}
