<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
require_once 'lib/config/appConfig.class.php';
require_once 'lib/customlib/database/json/JSON.class.php';
/**
 * Description of daoStructureJson
 *
 * @author pc3
 */
class daoStructureJson extends JSON {
    
    private $table_name;
    
    function __construct($table_name) {
        $this->table_name = strtolower($table_name);
    }

    
    protected function getFileName() {
               
        return $this->table_name . ".json";
    }
    
    protected function getJsonFile() {
        $_filename = appConfig::DATABASE_STRUCTURE_DATA_JSON . $this->getFileName();
        $_ret = self::open($_filename);
        if (!$_ret) 
            throw new Exception("No se pudo encontrar el archivo de estructura de base datos ($_filename)");
        return $_ret;
    }

    /**
     * 
     * @param String $id
     * @return \stdClass|boolean
     */
    static public function getStructure($tableName) {
        $_obj = new daoStructureJson($tableName);

        $ret = $_obj->getJsonFile();            

        return $ret;
    }
    
    
}
