<?php
/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of mysqlDAO
 *
 * @author guillermo
 */
class mysqlDAO {
    //put your code here

    protected static function formatFieldSelect($type,$fieldValue) {

            switch ($type){

             /*   case "date":
                    $_ret = "DATE_FORMAT($fieldValue, '".DbConfig::getDateFormat()."') as $fieldValue";
                    break;
                 case "datetime":
                    $_ret = "DATE_FORMAT($fieldValue, '".DbConfig::getDateTimeFormat()."') as $fieldValue";
                    break;*/
                default:
                    $_ret = "$fieldValue";
                    
            }

        return $_ret;
    }

    protected static function formatFieldInsert($type,$fieldValue) {
            switch ($type){                             
                case "date":
                    $_ret = null;
                    if ($fieldValue != null and $fieldValue instanceof DateTime ){
                        $_value = DateConversion::DateToDBFormat($fieldValue);
                        $_ret = "STR_TO_DATE('$_value', '".DbConfig::getRDBMSDateFormat()."')";
                    }
                    break;
                
                 case "datetime":
                     $_ret = null;
                     
                     if ($fieldValue != null and $fieldValue instanceof DateTime ){
                         
                         $_value = DateConversion::DateTimeToDBFormat($fieldValue);
                         $_ret = "STR_TO_DATE('$_value', '".DbConfig::getRDBMSDateTimeFormat()."')";
                     }
                    
                    break;

                case "tinyint":
                case "boolean":
                    if ( $fieldValue === "" or $fieldValue === false or $fieldValue === "null" or $fieldValue === null) 
                        $_ret = "0";
                    else 
                        $_ret = "'$fieldValue'";
                    break;

                case "int":
                    if ( $fieldValue === "" or $fieldValue === false or $fieldValue === "null" or $fieldValue === null)
                        $_ret = null;
                    else
                        $_ret = "'$fieldValue'";
                    break;

                default:
                    $_ret = "'$fieldValue'";
            }
            if ($_ret == null) return "null";

        return $_ret;
    }

    public function setValueByType(&$obj, $key, $value) {
        $method = "set" . ucfirst($key);

        if (method_exists(get_class($obj), $method)) {
            $fieldType = $this->getFieldType($key);

            switch ($fieldType) {
                case "datetime":
                    $obj->$method(DateConversion::DBFormatToDateTime($value));
                    break;
                case "date":
                    $obj->$method(DateConversion::DBFormatToDate($value));
                    break;
                case 'tinyint':
                case 'boolean':
                    $new_value = true;
                    if($value===null or $value==="0" or $value===0)
                        $new_value = false;
                    $obj->$method($new_value);
                    break;
                default :
                    $obj->$method($value);
                    break;
            }
        }
    }

}
?>
